﻿var aryTex = new Array('tex001','tex002','tex003','tex004','tex005');
var aryViewP = new Array('viewp001','viewp002','viewp003','viewp004','viewp005');
var aryPgA = new Array('page001a','page002a','page003a','page004a','page005a');
var aryPgB = new Array('page001b','page002b','page003b','page004b','page005b');

var TMan = new N6LTimerMan();
var num = 5; //メニュー項目・ページ数
var nsel = 0; //開かれるid
var sel = -1; //閉じられるid
var kwait = false; //キー入力受付フラグ
var sgn1 = 1; //符号
var time1 = 0; //テキスト回転アニメーション時間
var addFrame1 = 0.005; //テキスト回転アニメーションフレーム毎の増加時間
var time2 = 0; //ページ送りアニメーション時間
var addFrame2 = 0.05; //ページ送りアニメーションフレーム毎の増加時間

//キー入力
document.onkeyup = function (e){
  if(!e) e = window.event;
  var key_code = e.keyCode;
  if(!kwait) {
    if(key_code == 37) Left();
    if(key_code == 39) Right();
  }
};

//ロード
jQuery(document).ready(function(){
window.onload=function(){
  var n = 0;  
  if(window.location.search){
    n = window.location.search.substring(1,window.location.search.length) - 1;
  }
  nsel = n;
  ToView();
}
  var mousewheelevent = 'onwheel' in document ? 'wheel' : 'onmousewheel' in document ? 'mousewheel' : 'DOMMouseScroll';
  jQuery(document).on(mousewheelevent,function(e){
    if(!kwait) {
      e.preventDefault();
      var delta = e.originalEvent.deltaY ? -(e.originalEvent.deltaY) : e.originalEvent.wheelDelta ? e.originalEvent.wheelDelta : -(e.originalEvent.detail);
      if (delta < 0) Right();
      else Left();
    }
  });
  TMan.add();
  TMan.add();
  TMan.changeinterval(50);
  sgn1 = 1;
  time1 = 0;
  time2 = 0;
  kwait = true;
//  nsel = 0;
  sel = -1;

  //メニュー項目初期配置
  var r = 15;
  var th = 0;
  var i = 0;
  var x = 0;
  var y = 0;
  var rr = 30;
  var xx = 0;
  var yy = 0;
  for(i = 0; i < num; i++){
    th = (i / num) * (2 * Math.PI);
    x = r * Math.sin(th);
    y = r * Math.cos(th);
    xx = rr * Math.sin(th);
    yy = rr * Math.cos(th);
    var pos = new x3dom.fields.SFVec3f(x, 0, y);
    var rot = new x3dom.fields.SFVec4f(0, 1, 0, th);
    var posvp = new x3dom.fields.SFVec3f(xx, 2, yy);
    var rotvp = new x3dom.fields.SFVec4f(0, 1, 0, th);
    var elm = document.getElementById(aryTex[i]);
    elm.setAttribute('translation', pos.toString());
    elm.setAttribute('rotation', rot.toString());
    elm = document.getElementById(aryViewP[i]);
    elm.setAttribute('position', posvp.toString());
    elm.setAttribute('orientation', rotvp.toString());
    //ページ初期配置
    pos = new x3dom.fields.SFVec3f(0, -10, 0);
    elm = document.getElementById(aryPgA[i]);
    elm.setAttribute('translation', pos.toString());
  }
  ToView();
});

function ToView(){
  //メニュー項目アニメーション
  var elm = document.getElementById(aryViewP[nsel]);
  elm.setAttribute('set_bind','true');
  //ページアニメーション
  kwait = true;
  time2 = 0;
  if(sel == 0 || nsel == 0) TMan.timer[0].setalerm(function() { GLoop1(0); }, 50); //テキスト回転アニメーション登録
  TMan.timer[1].setalerm(function() { GLoop2(1); }, 50); //ページ送りアニメーション登録
}

function Left(){
  if(sel <= 0) nsel = num - 1;
  else nsel = sel - 1;
  ToView();
}

function Right(){
  if(num - 1 <= sel) nsel = 0;
  else nsel = sel + 1;
  ToView();
}

//テキスト回転アニメーション
function GLoop1(id){
  time1 += addFrame1;
  var t;
  if(0 < sgn1) t = time1;
  else t = 1 - time1;
  var th = 8 * Math.PI * Math.pow(2, -(Math.pow(8 * t - 4, 2))) * sgn1; // y = 8 π 2 ^ (-(8 x - 4) ^ 2) * sgn1 (0, 0 <= x, y <= 1, 8 π)

  var elm = document.getElementById('title003');
  var rot = new x3dom.fields.SFVec4f(1, 0, 0, th);
  elm.setAttribute('rotation', rot.toString());
  elm = document.getElementById('title002');
  rot = new x3dom.fields.SFVec4f(1, 0, 0, -th / 4);
  elm.setAttribute('rotation', rot.toString());
  elm = document.getElementById('title001');
  rot = new x3dom.fields.SFVec4f(1, 0, 0, th / 2);
  elm.setAttribute('rotation', rot.toString());

  if(1 <= time1) {
    if(0 < sgn1) sgn1 = -1;
    else sgn1 = 1;
    time1 = 0;
  }
  if(sel == 0 || nsel == 0) TMan.timer[id].setalerm(function() { GLoop1(id); }, 50); //ループ再登録
}

//ページ送りアニメーション
function GLoop2(id){
  time2 += addFrame2;
  var nselmA = document.getElementById(aryPgA[nsel]);
  var nselmB = document.getElementById(aryPgB[nsel]);

  var th = Math.PI / 4 + (Math.PI / 2) * time2;
  var th0 = Math.PI * 3 / 4;
  var posUP = new x3dom.fields.SFVec3f((Math.cos(th) - Math.cos(th0)) * 10, (Math.sin(th) - Math.sin(th0)) * 10, 0);
  var rotUP = new x3dom.fields.SFVec4f(0, 1, 0, time2 * 2 * Math.PI);
  nselmA.setAttribute('translation', posUP.toString());
  nselmB.setAttribute('rotation', rotUP.toString());
  if(0 <= sel) {
    var selm = document.getElementById(aryPgA[sel]);
    var posDOWN = new x3dom.fields.SFVec3f(0, -10 * time2, 0);
    selm.setAttribute('translation', posDOWN.toString());
  }

  if(1 <= time2){ kwait = false; sel = nsel; }
  if(kwait) TMan.timer[id].setalerm(function() { GLoop2(id); }, 50); //ループ再登録
}